package java.nio;

import sun.nio.ch.DirectBuffer;

class DirectCharBufferRU extends DirectCharBufferU implements DirectBuffer
{
    DirectCharBufferRU(DirectBuffer directBuffer, int n, int n2, int n3, int n4, int n5) {
        super(directBuffer, n, n2, n3, n4, n5);
    }
    
    @Override
    public CharBuffer slice() {
        int position = this.position();
        int limit = this.limit();
        int n = (position <= limit) ? (limit - position) : 0;
        int n2 = position << 1;
        assert n2 >= 0;
        return new DirectCharBufferRU(this, -1, 0, n, n, n2);
    }
    
    @Override
    public CharBuffer duplicate() {
        return new DirectCharBufferRU(this, this.markValue(), this.position(), this.limit(), this.capacity(), 0);
    }
    
    @Override
    public CharBuffer asReadOnlyBuffer() {
        return this.duplicate();
    }
    
    @Override
    public CharBuffer put(char c) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public CharBuffer put(int n, char c) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public CharBuffer put(CharBuffer charBuffer) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public CharBuffer put(char[] array, int n, int n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public CharBuffer compact() {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public boolean isDirect() {
        return true;
    }
    
    @Override
    public boolean isReadOnly() {
        return true;
    }
    
    @Override
    public String toString(int n, int n2) {
        if (n2 > this.limit() || n > n2) {
            throw new IndexOutOfBoundsException();
        }
        try {
            char[] value = new char[n2 - n];
            CharBuffer wrap = CharBuffer.wrap(value);
            CharBuffer duplicate = this.duplicate();
            duplicate.position(n);
            duplicate.limit(n2);
            wrap.put(duplicate);
            return new String(value);
        }
        catch (StringIndexOutOfBoundsException ex) {
            throw new IndexOutOfBoundsException();
        }
    }
    
    @Override
    public CharBuffer subSequence(int n, int n2) {
        int position = this.position();
        int limit = this.limit();
        assert position <= limit;
        int n3 = (position <= limit) ? position : limit;
        int n4 = limit - n3;
        if (n < 0 || n2 > n4 || n > n2) {
            throw new IndexOutOfBoundsException();
        }
        return new DirectCharBufferRU(this, -1, n3 + n, n3 + n2, this.capacity(), this.offset);
    }
    
    @Override
    public ByteOrder order() {
        return (ByteOrder.nativeOrder() != ByteOrder.BIG_ENDIAN) ? ByteOrder.LITTLE_ENDIAN : ByteOrder.BIG_ENDIAN;
    }
}
